;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


align_proc
BubbleSort proc dummy:dword
	mov		g_bActiveProcces, true
	.for (edi=ArraySize, bl=true: bl: edi--)
		.for (esi=1, bl=false: esi < edi: esi++)	;bl:swapped
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[esi], true
				mov		bComparison[esi-1], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			mov		eax, Array[esi*4-1*4]
			mov		edx, Array[esi*4]
			.if (sdword ptr edx < eax)
				mov		Array[esi*4], eax
				mov		Array[esi*4-1*4], edx
				mov		bl, true
				inc		countSwap
			.endif
		.endfor 
	.endfor
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al;=false
	mov		g_bPause, al;=false
	ret
BubbleSort endp

align_proc
BrickSort proc uses edi ebx dummy:dword
	mov		g_bActiveProcces, true
	xor		bl, bl	;=false		//флаг Ц были/не были перестановки в проходе
	.while (!bl)
		mov		bl, true
		mov		edi, 1
		.repeat
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[edi], true
				mov		bComparison[edi+1], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			mov		edx, Array[edi*4]
			mov		eax, Array[edi*4+4]
			.if (sdword ptr edx>eax)
				xor		bl, bl	;=false
				;swap(A[j-1], A[j])
				mov		Array[edi*4+4], edx
				mov		Array[edi*4], eax
				inc		countSwap
			.endif
			add		edi, 2
		.until (edi>=ArraySize-1)
		xor		edi, edi
		.repeat
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[edi], true
				mov		bComparison[edi+1], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			mov		edx, Array[edi*4]
			mov		eax, Array[edi*4+4]
			.if (sdword ptr edx>eax)
				xor		bl, bl	;=false
				;swap(A[j-1], A[j])
				mov		Array[edi*4+4], edx
				mov		Array[edi*4], eax
				inc		countSwap
			.endif
			add		edi, 2
		.until (edi>=ArraySize-1)
	.endw
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
BrickSort endp

align_proc
quick_sort proc uses esi edi ebx pArray:ptr sdword, len:sdword
	.if (!g_bBreak)
		mov		ebx, pArray
		ASSUME	ebx:ptr sdword
		mov		edx, len
		.if (edx>1)
			lea		esi, [edx - 1]	;j=len - 1
			;int pivot = pArray[len / 2];
			shr		edx, 1;/=2
			.for (edi=0, ecx=[ebx][edx*4]: : edi++, esi--)
				.for (:[ebx][edi*4] < ecx: edi++)
					;----------------------
					inc		countComp
					.repeat ;//приостановить процесс сортировки
						mov		bComparison[edi], true
						mov		bComparison[edx], true
						push	ecx
						push	edx
						Sleep(g_iDelayPause)	;чтобы не нагружало
						pop		edx
						pop		ecx
						cmp		g_bBreak, 0
						jne		EXIT
					.until (g_bPause==false)
					push	ecx
					push	edx
					Sleep(g_iDelay)
					pop		edx
					pop		ecx
					;----------------------
				.endfor
				.for (:[ebx][esi*4] > ecx: esi--)
					;----------------------
					inc		countComp
					.repeat ;//приостановить процесс сортировки
						mov		bComparison[esi], true
						mov		bComparison[edx], true
						push	ecx
						push	edx
						Sleep(g_iDelayPause)	;чтобы не нагружало
						pop		edx
						pop		ecx
						cmp		g_bBreak, 0
						jne		EXIT
					.until (g_bPause==false)
					push	ecx
					push	edx
					Sleep(g_iDelay)
					pop		edx
					pop		ecx
					;----------------------
				.endfor
				.break .if (edi >= esi)
				push	edx
				swap	[ebx][edi*4], [ebx][esi*4]
				;----------------------
				inc		countSwap
				push	ecx
				Sleep(g_iDelay)
				pop		ecx
				pop		edx
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endfor
			quick_sort(ebx, edi)
			mov		edx, len
			sub		edx, edi
			quick_sort(&[ebx][edi*4], edx)
		.endif
	.endif
	ASSUME	ebx:nothing
EXIT:
	ret
quick_sort endp

align_proc
QuickSort proc dummy:dword
	mov		g_bActiveProcces, true
	quick_sort(&Array, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
QuickSort endp

align_proc
ShakerSort proc dummy:dword
local left:dword
	mov		g_bActiveProcces, true
	mov		esi, ArraySize-1	;right
	mov		ebx, ArraySize-1	;control
	and		left, 0
	.repeat
		mov		edi, left	;i
		.repeat
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[edi], true
				mov		bComparison[edi+1], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			mov		edx, Array[edi*4]
			.if (edx>Array[edi*4+4])
				;swap(A[i+1], A[i])
				mov		eax, Array[edi*4+4]
				mov		Array[edi*4+4], edx
				mov		Array[edi*4], eax
				mov		ebx, edi
				inc		countSwap
			.endif
			inc		edi ;i--
		.until (edi>=esi)
		mov		esi, ebx
		mov		edi, ebx
		.repeat
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[edi], true
				mov		bComparison[edi-1], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			mov		edx, Array[edi*4]
			.if (edx<Array[edi*4-4])
				;swap(A[i-1], A[i])
				mov		eax, Array[edi*4-4]
				mov		Array[edi*4-4], edx
				mov		Array[edi*4], eax
				mov		ebx, edi
				inc		countSwap
			.endif
			dec		edi
		.until (edi<=left)
		mov		left, ebx
	.until (ebx>=esi)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
ShakerSort endp

align_proc
down_heap proc uses esi edi ebx pArray:ptr sdword, n:sdword, i:sdword
	ASSUME	esi:ptr sdword
	mov		esi, pArray
	mov		edi, i
	.while (true)
		;int j = max(esi, n, i, 2 * i + 1, 2 * i + 2);
		lea		ecx, [edi+edi+1]
		mov		ebx, edi
		mov		eax, [esi][ebx*4]
		.if (ecx < n && [esi][ecx*4] > eax)
			mov		ebx, ecx
		.endif
		lea		edx, [edi+edi+2]
		mov		eax, [esi][ebx*4]
		mov		bComparison[ebx], true
		.if (edx < n && [esi][edx*4] > eax)
			mov		ebx, edx
		.endif
		;----------------------
		inc		countComp
		.repeat ;//приостановить процесс сортировки
			mov		bComparison[edi], true
			.if (ecx < n)
				mov		bComparison[ecx], true
			.endif
			.if (edx < n)
				mov		bComparison[edx], true
			.endif
			push	ecx
			push	edx
			Sleep(g_iDelayPause)	;чтобы не нагружало
			pop		edx
			pop		ecx
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		Sleep(g_iDelay)
		;----------------------
		.break .if (ebx == edi)
		swap	[esi][edi*4], [esi][ebx*4]
		inc		countSwap
		mov		edi, ebx
	.endw
EXIT:
	ret
down_heap endp

align_proc
heap_sort proc uses esi edi ebx pArray:ptr sdword, len:sdword
    mov		esi, pArray
	mov		ebx, len
	.for (edi=ebx, edi-=2, edi/=2: sdword ptr edi >= 0: edi--)
		down_heap(esi, ebx, edi)
		cmp		g_bBreak, 0
		jne		EXIT
	.endfor
	.for (edi=0: sdword ptr edi < ebx: edi++)
		mov		ecx, ebx
		sub		ecx, edi
		dec		ecx	;z = len - edi - 1
		swap	[esi][0*4], [esi][ecx*4]
		down_heap(esi, ecx, 0)
		cmp		g_bBreak, 0
		jne		EXIT
	.endfor
	ASSUME	esi:nothing
EXIT:
	ret
heap_sort endp

align_proc
HeapSort proc  dummy:dword
	mov		g_bActiveProcces, true
	heap_sort(&Array, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
HeapSort endp

.const
align 4
Shell_table	sdword 21523351*4, 7174450*4, 2391483*4, 797161*4, 265720*4, 88573*4, 29524*4, 9841*4
			sdword     3280*4,    1093*4,     364*4,    121*4,     40*4,    13*4,     4*4,    1*4
.code

align_proc
ShellSort proc dummy:dword
local i:dword, j:dword
	mov		g_bActiveProcces, true
	mov		ecx, -17; 16 элементов в таблице приращений
	.repeat
		inc		ecx
	.until (Shell_table[ecx*4+16*4]<ArraySize); ищем максимальное приращение, соответствующее размеру нашего массива
	mov		j, ecx	;=Shell_index
	.repeat
		mov		ecx, j
		mov		edi, Shell_table[ecx*4+16*4]; элемент из таблицы соответствующий индексу
		; выбрали интервал,  у нас двойные слова, поэтому умножаем на 4
		mov		i, edi;i=gap
		.repeat
			mov		esi, i
			sub		esi, edi;j=i-gap
			.repeat
				;----------------------
				inc		countComp
				.repeat ;//приостановить процесс сортировки
					mov		eax, esi
					shr		eax, 2;/=4
					mov		edx, edi
					shr		edx, 2;/=4
					mov		bComparison[eax], true
					mov		bComparison[eax+edx], true
					Sleep(g_iDelayPause)	;чтобы не нагружало
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				Sleep(g_iDelay)
				;----------------------
				mov		edx, Array[esi];for(i=gap;i<dim;i++)/*проход массива*/
				.break .if (edx<=Array[esi+edi]);сравнение пар, отстоящих на gap друг от друга
				mov		eax, edx
				mov		edx, Array[esi+edi];swap(a[j],a[j+gap])
				mov		Array[esi+edi], eax
				mov		Array[esi], edx
				inc		countSwap
				sub		esi, edi  ; j-=gap
			.until (less?)
			add		i, 4    ;i++
		.until (i>=ArraySize*4)
		inc		j
	.until (zero?)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
ShellSort endp

align_proc
SelectionSort proc uses ebx dummy:dword
	mov		g_bActiveProcces, true
	xor		edi, edi
	.repeat
		mov		ebx, edi	;min_index
		lea		esi, [edi+1]	;for (j = i + 1; j < ArraySize; j++)
		.repeat
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[esi], true
				mov		bComparison[ebx], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			mov		eax, Array[esi*4]
			.if (eax<=Array[ebx*4])
				mov		ebx, esi;min_index = j
			.endif
			inc		esi
		.until (esi>=ArraySize)
		.if (ebx!=edi)
			mov		ecx, Array[edi*4]
			mov		eax, Array[ebx*4]
			mov		Array[ebx*4], ecx
			mov		Array[edi*4], eax
			;----------------------
			inc		countSwap
			;----------------------
		.endif
		inc		edi
	.until (edi>=ArraySize-1)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
SelectionSort endp

align_proc
GnomeSort proc dummy:dword
	mov		g_bActiveProcces, true
	mov		edi, 1
	.repeat
		.while (edi)
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[edi-1], true
				mov		bComparison[edi], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			mov		eax, Array[edi*4-4]
			.break .if (eax<=Array[edi*4])
			mov		edx, eax
			mov		eax, Array[edi*4]
			mov		Array[edi*4], edx
			mov     Array[edi*4-4], eax
			inc		countSwap
			dec     edi
		.endw
		inc		edi
	.until (edi>=ArraySize)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
GnomeSort endp

align_proc
CombSort proc  dummy:dword
local step:real4, factor:real4
	mov		g_bActiveProcces, true
	mov		factor, 0.801711879 ;= 1.0/1.2473309;
	;step = (float)ArraySize*factor;
	mov		eax, ArraySize
	cvtsi2ss xmm0, eax
	mulss	xmm0, factor	;137/1.2473309
	movss	step, xmm0
	.while (xmm0 > CFP4(1.0))
		cvtss2si esi, xmm0
		xor		edi, edi
		.repeat
			mov		edx, Array[edi*4]
			mov		eax, Array[esi*4]
			.if (sdword ptr edx>eax)
				mov		Array[edi*4], eax
				mov		Array[esi*4], edx
				inc		countSwap
			.endif
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[edi], true
				mov		bComparison[esi], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
			inc		edi
			inc		esi
		.until (esi>=ArraySize)
		movss	xmm0, step
		mulss	xmm0, factor
		movss	step, xmm0
	.endw
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
CombSort endp

align_proc
InsertionSort proc  dummy:dword
	mov		g_bActiveProcces, true
	xor		esi, esi	;i=0
	.repeat
		mov		ebx, esi		;min=i
		lea		edi, [esi+1]	;j=i+1
		.repeat
			mov		eax, Array[edi*4]
			.if (Array[ebx*4]>eax)
				mov		ebx, edi
			.endif
			inc		edi			;j++
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[edi], true
				mov		bComparison[ebx], true
				Sleep(g_iDelayPause)	;чтобы не нагружало
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			Sleep(g_iDelay)
			;----------------------
		.until (edi>=ArraySize)
		swap	Array[ebx*4], Array[esi*4]	;eax, edx
		;----------------------
		inc		countSwap
		;----------------------
		inc		esi			;i++
	.until (esi>=ArraySize-1)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
InsertionSort endp

static_int	temp, ArraySize dup(?)

align_proc
merge proc uses esi edi ebx iFirst:sdword, iHalf:sdword, iLast:sdword
	;int	first = iFirst, half = iHalf, cur = 0;
	.for (esi=iFirst, edi=iHalf, ebx=0: esi < iHalf && edi < iLast: ebx++)
		mov		eax, Array[esi*4]
		mov		edx, Array[edi*4]
		.if (sdword ptr eax < edx)
			mov		temp[ebx*4], eax
			inc		esi
		.else
			mov		temp[ebx*4], edx
			inc		edi
		.endif
		;----------------------
		inc		countComp
		.repeat ;//приостановить процесс сортировки
			mov		bComparison[esi], true
			mov		bComparison[edi], true
			Sleep(g_iDelayPause)	;чтобы не нагружало
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		Sleep(g_iDelay)
		;----------------------
	.endfor
	.for (:esi < iHalf :ebx++, esi++)
		mrm		temp[ebx*4], Array[esi*4]
	.endfor
	.for (:edi < iLast :ebx++, edi++)
		mrm		temp[ebx*4], Array[edi*4]
	.endfor
	.for (esi=iFirst, ebx=0: esi < iLast: esi++, ebx++)
		mrm		Array[esi*4], temp[ebx*4]
		;----------------------
		inc		countSwap
		Sleep(g_iDelay)
		.repeat ;//приостановить процесс сортировки
			Sleep(g_iDelayPause)	;чтобы не нагружало
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		;----------------------
	.endfor
EXIT:
	ret
merge endp

align_proc
merge_sort proc uses esi edi ebx iFirst:sdword, iLast:sdword
	.if (!g_bBreak)
		mov		esi, iFirst
		mov		edi, iLast
		mov		eax, edi
		sub		eax, esi	;(iLast - iFirst)
		.if (sdword ptr eax > 1)
			;int iHalf = iFirst + (iLast - iFirst)/2;
			shr		eax, 1;/=2
			lea		ebx, [esi+eax]	;iHalf
			merge_sort(esi, ebx)
			merge_sort(ebx, edi)
			merge(esi, ebx, edi)
		.endif
	.endif
	ret
merge_sort endp

align_proc
MergeSort proc  dummy:dword
	mov		g_bActiveProcces, true
	merge_sort(0, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
MergeSort endp

align_proc
do_flip proc uses esi edi ebx list:ptr sdword, num:sdword
    mov		esi, list
	ASSUME	esi:ptr sdword
	.for (edi=0, ebx=num, ebx--: sdword ptr edi<ebx: edi++, ebx--)
        swap	[esi][edi*4], [esi][ebx*4]
		;----------------------
		inc		countSwap
		Sleep(g_iDelay)
		.repeat ;//приостановить процесс сортировки
			Sleep(g_iDelayPause)	;чтобы не нагружало
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		;----------------------
    .endfor
EXIT:
	ret
do_flip endp

align_proc
pancake_sort proc uses esi edi ebx list:ptr sdword, len:sdword
    ;//If it's less than 2 long, just return it as sorting isn't really needed...
	.if (len>1)
		mov		esi, list
		xor		ebx, ebx	;moves=0
		.for (edi=len: edi>1: edi--)
			;//Find position of the max number in pos(0) to pos(i)
			xor		ecx, ecx	;max_num_pos=0;
			.for (edx=0: edx<edi: edx++)
				mov		eax, [esi][ecx*4]
				.if ([esi][edx*4] > eax)
					mov		ecx, edx
				.endif
				;----------------------
				inc		countComp
				.repeat ;//приостановить процесс сортировки
					mov		bComparison[ecx], true
					mov		bComparison[edx], true
					push	ecx
					push	edx
					Sleep(g_iDelayPause)	;чтобы не нагружало
					pop		edx
					pop		ecx
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				push	ecx
				push	edx
				Sleep(g_iDelay)
				pop		edx
				pop		ecx
				;----------------------
			.endfor
			lea		eax, [edi-1]
			.continue .if(ecx==eax)	;//It's where it need to be, skip
			;//Get the found max number to the beginning of the list (unless it already is)
			.if (ecx)
				inc		ebx
				do_flip(esi, &[ecx+1])
			.endif
			;//And then move it to the end of the range we're working with (pos(0) to pos(i))
			inc		ebx
			do_flip(esi, edi)
			;//Then everything above list[i-1] is sorted and don't need to be touched
			.break .if (g_bBreak)
		.endfor
	.endif
	ASSUME	esi:nothing
EXIT:
    mov		eax, ebx
	ret
pancake_sort endp

align_proc
PancakeSort proc  dummy:dword
	mov		g_bActiveProcces, true
	pancake_sort(&Array, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
PancakeSort endp

;//* sort unsigned ints *
align_proc
rad_sort_u proc uses esi edi ebx from:ptr sdword, to:ptr sdword, bit:dword
	ASSUME	esi:ptr sdword, edi:ptr sdword
	.if (!g_bBreak)
		mov		esi, from	;ll
		mov		edi, to		;rr
		mov		ebx, bit
		lea		eax, [esi+4]
		.if (ebx && edi >= eax)
			sub		edi, 4
			.for (::)
				;/* find left most with bit, and right most without bit, swap */
				.for (:esi < edi && !([esi] & ebx): esi+=4)
					;----------------------
					inc		countComp
					.repeat ;//приостановить процесс сортировки
						mov		eax, esi
						sub		eax, offset Array
						shr		eax, 2;/=4
						mov		bComparison[eax], true
						Sleep(g_iDelayPause)	;чтобы не нагружало
						cmp		g_bBreak, 0
						jne		EXIT
					.until (g_bPause==false)
					Sleep(g_iDelay)
					;----------------------
				.endfor
				.for (:esi < edi &&  ([edi] & ebx): edi-=4)
					;----------------------
					inc		countComp
					.repeat ;//приостановить процесс сортировки
						mov		eax, edi
						sub		eax, offset Array
						shr		eax, 2;/=4
						mov		bComparison[eax], true
						Sleep(g_iDelayPause)	;чтобы не нагружало
						cmp		g_bBreak, 0
						jne		EXIT
					.until (g_bPause==false)
					Sleep(g_iDelay)
					;----------------------
				.endfor
				.break .if (esi >= edi)
				swap	[esi], [edi]
				;----------------------
				inc		countSwap
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endfor
			.if (!(ebx & [esi]) && esi < to)
				add		esi, 4
			.endif
			shr		ebx, 1
			rad_sort_u(from, esi, ebx)
			rad_sort_u(esi, to, ebx)
		.endif
	.endif
EXIT:
	ret
rad_sort_u endp

INT_MIN			= -2147483648
;//* sort signed ints: flip highest bit, sort as unsigned, flip back *
align_proc
radix_sort proc uses esi edi list:ptr sdword, len:dword
	mov		esi, list
	mov		edi, len
	.for (ecx = 0: ecx < edi: ecx++) 
		xor		[esi][ecx*4], INT_MIN
	.endfor
	rad_sort_u(esi, &[esi+edi*4], INT_MIN)
	.for (ecx = 0: ecx < edi: ecx++) 
		xor		[esi][ecx*4], INT_MIN
	.endfor
	ASSUME	esi:nothing, edi:nothing
	ret
radix_sort endp

align_proc
RadixSort proc  dummy:dword
	mov		g_bActiveProcces, true
	radix_sort(&Array, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
RadixSort endp

align_proc
stooge_sort proc uses esi edi ebx list:ptr sdword, i:sdword, j:sdword
	ASSUME	esi:ptr sdword
	cmp		g_bBreak, 0
	jne		EXIT
	mov		esi, list
	mov		edi, i
	mov		ebx, j
	inc		countComp
	mov		eax, [esi][edi*4]
	mov		edx, [esi][ebx*4]
	.if (sdword ptr edx < eax)
		mov		[esi][edi*4], edx
		mov		[esi][ebx*4], eax
		;----------------------
		;время сортировки почти кубическая, поэтому задержку даём в момент обмена
		inc		countSwap	
		.repeat ;//приостановить процесс сортировки
			mov		bComparison[edi], true
			mov		bComparison[ebx], true
			Sleep(g_iDelayPause)	;чтобы не нагружало
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		Sleep(g_iDelay)
		;----------------------
	.endif
	mov		esi, ebx
	sub		esi, edi	;=ebx - edi
	.if (sdword ptr esi > 1)
		;t = (ebx - edi + 1) / 3;
		inc		esi
		mov		eax, 055555556h
		imul	esi
		shr		esi, 31
		add		esi, edx	;t
		neg		esi		;-t
		stooge_sort(list, edi, &[ebx + esi])
		neg		esi		;+t
		stooge_sort(list, &[edi + esi], ebx)
		neg		esi		;-t
		stooge_sort(list, edi, &[ebx + esi])
	.endif
;;	ASSUME	esi:nothing
EXIT:
   ret
stooge_sort endp

align_proc
StoogeSort proc  dummy:dword
	mov		g_bActiveProcces, true
	stooge_sort(&Array, 0, ArraySize-1)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
StoogeSort endp

align_proc
cycle_sort proc uses esi edi ebx list:ptr sdword, l_len:dword
local l_len_1:dword
	mov		esi, list
	;//* Loop through the array to find cycles to rotate. *
	mov		eax, l_len
	dec		eax
	mov		l_len_1, eax
	.for (edi=0: edi < l_len_1: edi++);cycleStart
		mov		ecx, [esi][edi*4];item
		;//* Find where to put the item. *
		mov		ebx, edi	;pos
		.for (eax = edi, eax++: eax < l_len: eax++);i
			.if ([esi][eax*4] < ecx)
				inc		ebx
			.endif
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[eax], true
				mov		bComparison[edi], true
				push	eax
				push	ecx
				Sleep(g_iDelayPause)	;чтобы не нагружало
				pop		ecx
				pop		eax
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			push	eax
			push	ecx
			Sleep(g_iDelay)
			pop		ecx
			pop		eax
			;----------------------
		.endfor
		;//* If the item is already there, this is not a cycle. *
		.continue .if (ebx == edi)
		;//* Otherwise, put the item there or right after any duplicates. *
		.while ([esi][ebx*4] == ecx)
			;----------------------
			inc		countComp
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[ebx], true
				mov		bComparison[edi], true
				push	ecx
				Sleep(g_iDelayPause)	;чтобы не нагружало
				pop		ecx
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			push	ecx
			Sleep(g_iDelay)
			pop		ecx
			;----------------------
			inc		ebx
		.endw
		mov		edx, ebx
		mov		eax, [esi][ebx*4]
		mov		[esi][ebx*4], ecx
		mov		ecx, eax
		inc		countSwap
		;//* Rotate the rest of the cycle. *
		.while (ebx != edi)
			;//* Find where to put the item. *
			mov		ebx, edi
			.for (eax = edi, eax++: eax < l_len: eax++);i
				.if ([esi][eax*4] < ecx)
					inc		ebx
				.endif
				;----------------------
				inc		countComp
				.repeat ;//приостановить процесс сортировки
					mov		bComparison[eax], true
					mov		bComparison[edx], true
					push	eax
					push	ecx
					push	edx
					Sleep(g_iDelayPause)	;чтобы не нагружало
					pop		edx
					pop		ecx
					pop		eax
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				push	eax
				push	ecx
				push	edx
				Sleep(g_iDelay)
				pop		edx
				pop		ecx
				pop		eax
				;----------------------
			.endfor
			;//* Put the item there or right after any duplicates. *
			.while ([esi][ebx*4] == ecx)
				;----------------------
				inc		countComp
				.repeat ;//приостановить процесс сортировки
					mov		bComparison[ebx], true
					mov		bComparison[edx], true
					push	ecx
					push	edx
					Sleep(g_iDelayPause)	;чтобы не нагружало
					pop		edx
					pop		ecx
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				push	ecx
				push	edx
				Sleep(g_iDelay)
				pop		edx
				pop		ecx
				;----------------------
				inc		ebx
			.endw
			mov		edx, ebx
			mov		eax, [esi][ebx*4]
			mov		[esi][ebx*4], ecx
			mov		ecx, eax
			inc		countSwap
		.endw
	.endfor
EXIT:
	ret
cycle_sort endp

align_proc
CycleSort proc  dummy:dword
	mov		g_bActiveProcces, true
	cycle_sort(&Array, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
CycleSort endp

align_proc
cocktail_sort proc uses esi edi ebx list:ptr sdword, len:dword
local start_list[2]:dword, end_list[2]:dword, inc_list[2]:dword
	mov		esi, list
	mov		edx, len
	lea		eax, [edx-1]
	mov		start_list[0*4], 1
	mov		start_list[1*4], eax
	mov		end_list[0*4], edx
	and		end_list[1*4], 0
	mov		inc_list[0*4], 1
	mov		inc_list[1*4], -1
	mov		cl, false	;flag
	.while (!cl)
		;// packing two similar loops into one
		.for (edi = 0: edi < 2: edi++);it
			mov		cl, true
			.for (ebx = start_list[edi*4]: ebx != end_list[edi*4]: ebx += inc_list[edi*4]);i
				mov		eax, [esi][ebx*4]
				mov		edx, [esi][ebx*4-1*4]
				.if (sdword ptr edx > eax)
					mov		[esi][ebx*4], edx
					mov		[esi][ebx*4-1*4], eax
					inc		countSwap
					mov		cl, false
				.endif
				;----------------------
				inc		countComp
				.repeat ;//приостановить процесс сортировки
					mov		bComparison[ebx], true
					mov		bComparison[ebx-1], true
					push	ecx
					Sleep(g_iDelayPause)	;чтобы не нагружало
					pop		ecx
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				push	ecx
				Sleep(g_iDelay)
				pop		ecx
				;----------------------
			.endfor
			.break .if (cl)
		.endfor
	.endw
EXIT:
	ret
cocktail_sort endp

align_proc
CocktailSort proc  dummy:dword
	mov		g_bActiveProcces, true
	cocktail_sort(&Array, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
CocktailSort endp

.data?
count			sdword ColumnHeight dup (?)
.code

align_proc
counting_sort_mm proc uses esi edi ebx pArray:ptr sdword, len:sdword, min:sdword, max:sdword
	mov		esi, pArray
	mov		ebx, max
	sub		ebx, min
	inc		ebx		;range = max - min + 1;
	;int *count = malloc(range * sizeof(*array));
	.for (edi = 0: edi < ebx: edi++)
		and		count[edi*4], 0
	.endfor
	.for (edi = 0: edi < len: edi++)
		mov		eax, [esi][edi*4]
		sub		eax, min
		inc		count[eax*4]
		;----------------------
		inc		countComp
		.repeat ;//приостановить процесс сортировки
			mov		bComparison[edi], true
			Sleep(g_iDelayPause)	;чтобы не нагружало
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		Sleep(g_iDelay)
		;----------------------
	.endfor
	.for (edi = min, ebx = 0: edi <= max: edi++);i
		mov		edx, edi
		sub		edx, min
		.for (ecx = 0:ecx < count[edx*4]: ecx++, ebx++);j
			mov		[esi][ebx*4], edi
			;----------------------
			inc		countSwap
			.repeat ;//приостановить процесс сортировки
				mov		bComparison[ebx], true
				push	ecx
				push	edx
				Sleep(g_iDelayPause)	;чтобы не нагружало
				pop		edx
				pop		ecx
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			push	ecx
			push	edx
			Sleep(g_iDelay)
			pop		edx
			pop		ecx
			;----------------------
		.endfor
	.endfor
EXIT:
	;free(count)
	ret
counting_sort_mm endp

align_proc
CountingSort proc  dummy:dword
	mov		g_bActiveProcces, true
	counting_sort_mm(&Array, ArraySize, 0, ColumnHeight)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
CountingSort endp

